--------------------------------------------------------------------------------
-- Stand Alone Uplink: FPGA Design
-- LIGO document: D060288
-- SubModule GPS_Sync
-- Created   9/25/2006 3:49:25 PM
--------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

entity GPS_Sync is port
   (
     CLK         : in    std_logic;
     ONEPPS      : in    std_logic;
     CNT         : out   std_logic_vector(25 downto 0)
   );
end GPS_Sync;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of GPS_Sync is

-- Signal Declarations
   signal counter : unsigned (25 downto 0);
   signal ONEPPSOLD : std_logic;

begin

   ONEPPSOLD <= ONEPPS when rising_edge (CLK);

   process (CLK, ONEPPS) is
   begin
      if rising_edge (CLK) then
         if (ONEPPS = '1') and (ONEPPSOLD = '0') then
            counter <= B"00" & X"000001";
         else
            counter <= counter + 1;
         end if;
      end if;
   end process;

   CNT <= std_logic_vector (counter);

end architecture Structure;

